diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_links.c ircd-hybrid-6.0/src/m_links.c
--- ircd-hybrid-6.0.orig/src/m_links.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/m_links.c	Wed Jun  6 17:40:30 2001
@@ -121,7 +121,7 @@
 
   assert(0 != mask);
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       /* reject non local requests */
       if(!MyClient(sptr))
@@ -157,11 +157,11 @@
 
   if (bogus_server)
     {
-      sendto_realops_flags(FLAGS_SPY,
-                         "BOGUS LINKS '%s' requested by %s (%s@%s) [%s]",
-                         clean_string(clean_mask, (const unsigned char *) mask, 2 * HOSTLEN),
-                         sptr->name, sptr->username,
-                         sptr->host, sptr->user->server);
+      sendto_realops_flag(UMODE_SPY,
+			  "BOGUS LINKS '%s' requested by %s (%s@%s) [%s]",
+			  clean_string(clean_mask, (const unsigned char *) mask, 2 * HOSTLEN),
+			  sptr->name, sptr->username,
+			  sptr->host, sptr->user->server);
       return 0;
     }
 
@@ -169,10 +169,10 @@
     mask = collapse(clean_string(clean_mask, (const unsigned char *) mask, 2 * HOSTLEN));
 
   if (MyConnect(sptr))
-    sendto_realops_flags(FLAGS_SPY,
-                       "LINKS '%s' requested by %s (%s@%s) [%s]",
-                       mask, sptr->name, sptr->username,
-                       sptr->host, sptr->user->server);
+    sendto_realops_flag(UMODE_SPY,
+			"LINKS '%s' requested by %s (%s@%s) [%s]",
+			mask, sptr->name, sptr->username,
+			sptr->host, sptr->user->server);
   
   for (acptr = GlobalClientList; acptr; acptr = acptr->next) 
     {
@@ -180,7 +180,7 @@
         continue;
       if (*mask && !match(mask, acptr->name))
         continue;
-      if(IsAnOper(sptr))
+      if(SeesAllConnections(sptr))
          sendto_one(sptr, form_str(RPL_LINKS),
                     me.name, parv[0], acptr->name, acptr->serv->up,
                     acptr->hopcount, (acptr->info[0] ? acptr->info :
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_list.c ircd-hybrid-6.0/src/m_list.c
--- ircd-hybrid-6.0.orig/src/m_list.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_list.c	Tue Jun  5 19:01:50 2001
@@ -59,7 +59,7 @@
   if(!MyConnect(sptr))
     return 0;
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       if(((last_used + PACE_WAIT) > CurrentTime) && (!IsDoingList(sptr)))
         {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_locops.c ircd-hybrid-6.0/src/m_locops.c
--- ircd-hybrid-6.0.orig/src/m_locops.c	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/src/m_locops.c	Wed Jun  6 11:39:18 2001
@@ -110,7 +110,7 @@
         {
 #ifdef NEED_ULINES
           sendto_realops("received Unauthorized locops from %s",sptr->name);
- #endif
+#endif
           return 0;
         }
 
@@ -159,7 +159,7 @@
       return 0;
     }
 
-  if(MyConnect(sptr) && IsAnOper(sptr))
+  if(MyConnect(sptr) && SendWallops(sptr))
     {
 
 #ifdef SLAVE_SERVERS
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_ltrace.c ircd-hybrid-6.0/src/m_ltrace.c
--- ircd-hybrid-6.0.orig/src/m_ltrace.c	Fri Nov 24 18:51:17 2000
+++ ircd-hybrid-6.0/src/m_ltrace.c	Fri Jun  8 12:24:55 2001
@@ -117,8 +117,14 @@
     return 0;
 
 #ifdef SERVERHIDE
-  if (!IsAnOper(sptr))
-    return 0;
+  if (!SeesAllConnections(sptr))
+    {
+      if (!SeesOperMessages(sptr))
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      else
+	sendto_one(sptr,":%s NOTICE %s :You have no a umode",me.name,parv[0]);
+      return 0;
+    }
 #endif
 
   if (parc > 2)
@@ -154,17 +160,17 @@
 
 
   if(MyClient(sptr))
-    sendto_realops_flags(FLAGS_SPY, "ltrace requested by %s (%s@%s) [%s]",
-                       sptr->name, sptr->username, sptr->host,
-                       sptr->user->server);
+    sendto_realops_flag(UMODE_SPY, "ltrace requested by %s (%s@%s) [%s]",
+			sptr->name, sptr->username, sptr->host,
+			sptr->user->server);
 
 
   doall = (parv[1] && (parc > 1)) ? match(tname, me.name): TRUE;
   wilds = !parv[1] || strchr(tname, '*') || strchr(tname, '?');
   dow = wilds || doall;
 
-  if(!IsAnOper(sptr) || !dow) /* non-oper traces must be full nicks */
-                              /* lets also do this for opers tracing nicks */
+  if(!IsSetOperAuspex(sptr) || !dow) /* non-oper traces must be full nicks */
+                                     /* lets also do this for opers tracing nicks */
     { 
       const char* name;
       const char* ip;
@@ -184,12 +190,12 @@
 
       c_class = get_client_class(acptr);
 
-      if (IsAnOper(acptr))
+      if (SeesOpers(sptr) && IsAnOper(acptr))
         { 
           sendto_one(sptr, form_str(RPL_TRACEOPERATOR),
                      me.name, parv[0], c_class,
                      name,
-                     IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
+                     IsSetOperAuspex(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip),
                      now - acptr->lasttime,
                      (acptr->user)?(now - acptr->user->last):0);
         }
@@ -201,7 +207,7 @@
   for (i = 0; i < MAXCONNECTIONS; i++)
     link_s[i] = 0, link_u[i] = 0;
                         
-  if (dow && LIFESUX && !IsOper(sptr))
+  if (dow && LIFESUX && !SendWhileLifeSucks(sptr))
     {
       sendto_one(sptr,form_str(RPL_LOAD2HI),me.name,parv[0]);
       return 0;
@@ -228,8 +234,8 @@
       if (!(acptr = local[i])) /* Local Connection? */
         continue;
       if (IsInvisible(acptr) && dow &&
-          !(MyConnect(sptr) && IsAnOper(sptr)) &&
-          !IsAnOper(acptr) && (acptr != sptr))
+          !SeesAllConnections(sptr) &&
+          (acptr != sptr))
         continue;
       if (!doall && wilds && !match(tname, acptr->name))
         continue;
@@ -251,16 +257,17 @@
           break;
         case STAT_CLIENT:
           /* Well, most servers don't have a LOT of OPERs... let's show them too */
-          if ((IsAnOper(sptr) &&
+
+          if ((IsSetOperAuspex(sptr) &&
               (MyClient(sptr) || !(dow && IsInvisible(acptr))))
-              || !dow || IsAnOper(acptr))
+              || !dow || (IsAnOper(acptr) && SeesOpers(sptr)))
             {
               if (IsAnOper(acptr))
                 sendto_one(sptr,
                            form_str(RPL_TRACEOPERATOR),
                            me.name, parv[0], c_class,
                            name, 
-                           IsAnOper(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip), 
+                           IsSetOperAuspex(sptr)?ip:(IsIPHidden(acptr)?"127.0.0.1":ip), 
                            now - acptr->lasttime,
                            (acptr->user)?(now - acptr->user->last):0);
               cnt++;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_lusers.c ircd-hybrid-6.0/src/m_lusers.c
--- ircd-hybrid-6.0.orig/src/m_lusers.c	Thu Jul 29 08:11:48 1999
+++ ircd-hybrid-6.0/src/m_lusers.c	Tue Jun  5 20:25:44 2001
@@ -100,7 +100,7 @@
 {
   static time_t last_used = 0;
 
-  if (!IsAnOper(sptr))
+  if (!NoFloodProtection(sptr))
     {
       if ((last_used + PACE_WAIT) > CurrentTime)
         {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_makepass.c ircd-hybrid-6.0/src/m_makepass.c
--- ircd-hybrid-6.0.orig/src/m_makepass.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/m_makepass.c	Tue Jun  5 20:25:56 2001
@@ -113,7 +113,7 @@
       return 0;
     }
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       if((last_used + PACE_WAIT) > CurrentTime)
         {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_map.c ircd-hybrid-6.0/src/m_map.c
--- ircd-hybrid-6.0.orig/src/m_map.c	Fri Jun  8 18:03:39 2001
+++ ircd-hybrid-6.0/src/m_map.c	Tue Jun  5 20:32:18 2001
@@ -87,7 +87,7 @@
 {
   static time_t   last_used = 0;
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       /* reject non local requests */
       if(!MyClient(sptr))
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_message.c ircd-hybrid-6.0/src/m_message.c
--- ircd-hybrid-6.0.orig/src/m_message.c	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/src/m_message.c	Wed Jun  6 17:40:38 2001
@@ -206,7 +206,7 @@
        * - Andre Guibert de Bruet <webdev@cheetah.properkernel.com>
        */
       if(chptr->mode.mode & MODE_NOCOLOR)
-        if(strchr(parv[2], 3) && !IsAnOper(sptr))
+        if(strchr(parv[2], 3) && !IsSetOperGod(sptr))
           { 
             sendto_one(sptr, form_str(ERR_NOCOLORSTOCHAN),
                        me.name, parv[0], nick);
@@ -343,7 +343,7 @@
 #endif /* DEATHFLUD */
 #endif /* FLUD */
 #ifdef ANTI_DRONE_FLOOD
-      if(MyConnect(acptr) && IsClient(sptr) && !IsAnOper(sptr) && DRONETIME)
+      if(MyConnect(acptr) && IsClient(sptr) && !NoFloodProtection(sptr) && DRONETIME)
         {
           if((acptr->first_received_message_time+DRONETIME) < CurrentTime)
             {
@@ -357,11 +357,11 @@
                 {
                   if(acptr->drone_noticed == 0) /* tiny FSM */
                     {
-                      sendto_ops_flags(FLAGS_BOTS,
-                             "Possible Drone Flooder %s [%s@%s] on %s target: %s",
-                                     sptr->name, sptr->username,
-                                     sptr->host,
-                                     sptr->user->server, acptr->name);
+                      sendto_ops_flag(UMODE_BOTS,
+				      "Possible Drone Flooder %s [%s@%s] on %s target: %s",
+				      sptr->name, sptr->username,
+				      sptr->host,
+				      sptr->user->server, acptr->name);
                       acptr->drone_noticed = 1;
                     }
                   /* heuristic here, if target has been getting a lot
@@ -375,12 +375,12 @@
                     {
                       if(acptr->drone_noticed == 1) /* tiny FSM */
                         {
-                          sendto_ops_flags(FLAGS_BOTS,
-                         "ANTI_DRONE_FLOOD SendQ protection activated for %s",
-                                         acptr->name);
+                          sendto_ops_flag(UMODE_BOTS,
+					  "ANTI_DRONE_FLOOD SendQ protection activated for %s",
+					  acptr->name);
 
                           sendto_one(acptr,     
- ":%s NOTICE %s :*** Notice -- Server drone flood protection activated for %s",
+				     ":%s NOTICE %s :*** Notice -- Server drone flood protection activated for %s",
                                      me.name, acptr->name, acptr->name);
                           acptr->drone_noticed = 2;
                         }
@@ -470,7 +470,7 @@
   if ((*nick == '$' || *nick == '>'))
     {
 
-      if(!IsAnOper(sptr))
+      if(!CanSendMassNotice(sptr))
         {
           sendto_one(sptr, form_str(ERR_NOSUCHNICK),
                      me.name, parv[0], nick);
@@ -519,7 +519,7 @@
        * -Dianora
        */
 
-      if( (char *)strchr(nick,'%') && !IsAnOper(sptr))
+      if( (char *)strchr(nick,'%') /* && !Is??????(sptr) disabled until we figure out what this is for -- asuffield */)
         {
           sendto_one(sptr, form_str(ERR_NOSUCHNICK),
                      me.name, parv[0], nick);
@@ -541,12 +541,15 @@
       *server = '\0';
 
       /* special case opers@server */
-      if(!irccmp(nick,"opers") && IsAnOper(sptr))
+      /* We don't want this on OPN -- asuffield */
+#if 0
+      if(!irccmp(nick,"opers") && SendWallops(sptr))
         {
           sendto_realops("To opers: From %s: %s",sptr->name,parv[2]);
           msgs++;
           continue;
         }
+#endif
         
       if ((host = (char *)strchr(nick, '%')))
         *host++ = '\0';
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_oper.c ircd-hybrid-6.0/src/m_oper.c
--- ircd-hybrid-6.0.orig/src/m_oper.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_oper.c	Fri Jun  8 17:13:14 2001
@@ -109,12 +109,17 @@
 #ifdef CRYPT_OPER_PASSWORD
   extern char * libshadow_md5_crypt(const char *pw, const char *salt);
 #endif /* CRYPT_OPER_PASSWORD */
-  char *operprivs;
   static char buf[BUFSIZE];
 
   password = parc > 2 ? parv[2] : (parc > 1 ? parv[1] : (char *)NULL);
   name = parc > 2 ? parv[1] : (parc > 1 ? sptr->name : (char *)NULL);
 
+  if (cptr != sptr)
+    {
+      sendto_ops_flag(UMODE_DEBUG, "Somebody tried to OPER but cptr != sptr (OPER %s from %s)", name, parv[0]);
+      return 0;
+    }
+
   if (!IsServer(cptr) && (EmptyString(name) || EmptyString(password)))
     {
       sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
@@ -123,15 +128,22 @@
     }
         
   /* if message arrived from server, trust it, and set to oper */
-  
-  if ((IsServer(cptr) || IsMe(cptr)) && !IsOper(sptr))
+  /* uhh.... not unless somebody can give me a damn good reason why OPER messages
+   * should ever come from a server
+   *  -- asuffield
+   */
+  if ((IsServer(cptr) || IsMe(cptr)))
     {
-      sptr->flags |= FLAGS_OPER;
-      Count.oper++;
-      sendto_serv_butone(cptr, ":%s MODE %s :+o", parv[0], parv[0]);
-      if (IsMe(cptr))
-        sendto_one(sptr, form_str(RPL_YOUREOPER),
-                   me.name, parv[0]);
+      sendto_ops_flag(UMODE_DEBUG, "WTF: %s received OPER message for %s from server %s", 
+		      me.name, sptr->name, cptr->name);
+      /* This doesn't work properly; it doesn't add them to the oper list locally.
+	SetBit(sptr->umodes,UMODE_OPER);
+	Count.oper++;
+	sendto_serv_butone(cptr, ":%s MODE %s :+o", parv[0], parv[0]);
+	if (IsMe(cptr))
+	sendto_one(sptr, form_str(RPL_YOUREOPER),
+	me.name, parv[0]);
+      */
       return 0;
     }
   else if (IsAnOper(sptr))
@@ -176,77 +188,59 @@
   if ((aconf->status & CONF_OPS) &&
       0 == strcmp(encr, aconf->passwd) && !attach_conf(sptr, aconf))
     {
-      int old = (sptr->umodes & ALL_UMODES);
-      
+      umode_t old;
+      CopyUmodes(old, sptr->umodes);
+
+      OrUmodes(sptr->allowed_umodes, aconf->allowed_umodes, user_umodes);
+      OrUmodes(sptr->umodes, sptr->umodes, aconf->default_umodes);
+      AndUmodes(sptr->umodes, sptr->umodes, sptr->allowed_umodes);
+
       if (aconf->status == CONF_LOCOP)
         {
           SetLocOp(sptr);
-          if((int)aconf->hold)
-            {
-              sptr->umodes |= ((int)aconf->hold & ALL_UMODES); 
-              sendto_one(sptr, ":%s NOTICE %s :*** Oper flags set from conf",
-                         me.name,parv[0]);
-            }
-          else
-            {
-              sptr->umodes |= (LOCOP_UMODES);
-            }
+	  SetBit(sptr->allowed_umodes,UMODE_LOCOP);
         }
       else
         {
           SetOper(sptr);
-          if((int)aconf->hold)
-            {
-              sptr->umodes |= ((int)aconf->hold & ALL_UMODES); 
-              if( !IsSetOperN(sptr) )
-                sptr->umodes &= ~FLAGS_NCHANGE;
-              if( !IsSetOperGod(sptr) )
-                sptr->umodes &= ~FLAGS_GOD;
-              if( !IsSetOperM(sptr) )
-                sptr->umodes &= ~FLAGS_IMMUNE;
-              if( !IsSetOperAuspex(sptr) )
-                sptr->umodes &= ~FLAGS_AUSPEX;
-              
-              sendto_one(sptr, ":%s NOTICE %s :*** Oper flags set from conf",
-                         me.name,parv[0]);
-            }
-          else
-            {
-              sptr->umodes |= (OPER_UMODES);
-            }
+	  SetBit(sptr->allowed_umodes,UMODE_OPER);
         }
-      SetIPHidden(sptr);
+      /*      SetIPHidden(sptr); */
       Count.oper++;
 
-      SetElined(cptr);
-      SetExemptGline(cptr);
+      /* No more of this oper-magic. If you're supposed to be exempt from
+       * G:lines/E:lined, you need an E:line/G:line exception in ircd.conf
+       *  -- asuffield
+       */
+      /*
+	SetElined(cptr);
+	SetExemptGline(cptr);
+      */
       
       /* LINKLIST */  
       /* add to oper link list -Dianora */
       cptr->next_oper_client = oper_cptr_list;
       oper_cptr_list = cptr;
 
-      if(cptr->confs)
-        {
-          struct ConfItem *aconf;
-          aconf = cptr->confs->value.aconf;
-          operprivs = oper_privs_as_string(cptr,aconf->port);
-        }
+      if (IsAlwaysBusy(sptr))
+	fdlist_add(sptr->fd, FDL_OPER | FDL_BUSY);
       else
-        operprivs = "";
-
-      fdlist_add(sptr->fd, FDL_OPER | FDL_BUSY);
+	fdlist_add(sptr->fd, FDL_OPER);
 #ifdef CUSTOM_ERR
       sendto_ops("%s (%s@%s) just activated an %c-line, hmmm.", parv[0],
 #else
       sendto_ops("%s (%s@%s) is now operator (%c)", parv[0],
 #endif /* CUSTOM_ERR */
                  sptr->username, sptr->host,
-                 IsOper(sptr) ? 'O' : 'o');
+                 IsLocOp(sptr) ? 'o' : 'O');
       send_umode_out(cptr, sptr, old);
       sendto_one(sptr, form_str(RPL_YOUREOPER), me.name, parv[0]);
-      sendto_one(sptr, ":%s NOTICE %s :*** Oper privs are %s",me.name,parv[0],
-                 operprivs);
+      {
+	umode_t privs;
+	AndNotUmodes(privs, sptr->allowed_umodes, user_umodes);
+	sendto_one(sptr, ":%s NOTICE %s :*** Oper privs are %s",me.name,parv[0],
+		   oper_flags_as_string(privs));
+      }
 
       SendMessageFile(sptr, &ConfigFileEntry.opermotd);
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_operwall.c ircd-hybrid-6.0/src/m_operwall.c
--- ircd-hybrid-6.0.orig/src/m_operwall.c	Tue Aug 10 03:46:24 1999
+++ ircd-hybrid-6.0/src/m_operwall.c	Wed Jun  6 11:43:14 2001
@@ -101,7 +101,7 @@
 
   if (check_registered_user(sptr))
     return 0;
-  if (!IsAnOper(sptr) || IsServer(sptr))
+  if (!SendOperwall(sptr) || IsServer(sptr))
     {
       if (MyClient(sptr) && !IsServer(sptr))
         sendto_one(sptr, form_str(ERR_NOPRIVILEGES),
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_pong.c ircd-hybrid-6.0/src/m_pong.c
--- ircd-hybrid-6.0.orig/src/m_pong.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_pong.c	Wed Jun  6 18:30:19 2001
@@ -123,7 +123,7 @@
     {
       if (!got_server_pong)
         {
-          sendto_ops_flags_butone(cptr, FLAGS_SERVNOTICE, "%s acknowledged end of %s burst (%i sec)",
+          sendto_ops_flag_butone(cptr, UMODE_SERVNOTICE, "%s acknowledged end of %s burst (%i sec)",
                      sptr->name, &me.name, CurrentTime - sptr->firsttime);
         }
       got_server_pong = 1;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_quit.c ircd-hybrid-6.0/src/m_quit.c
--- ircd-hybrid-6.0.orig/src/m_quit.c	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/src/m_quit.c	Mon Jun  4 18:36:45 2001
@@ -28,6 +28,7 @@
 #include "numeric.h"
 #include "s_serv.h"
 #include "send.h"
+#include "ctype.h"
 
 /*
  * m_functions execute protocol messages on this server:
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_rehash.c ircd-hybrid-6.0/src/m_rehash.c
--- ircd-hybrid-6.0.orig/src/m_rehash.c	Fri Jun  8 18:03:35 2001
+++ ircd-hybrid-6.0/src/m_rehash.c	Wed Jun  6 11:43:19 2001
@@ -100,15 +100,12 @@
 {
   int found = NO;
 
-  if (!MyClient(sptr) || !IsAnOper(sptr))
+  if (!MyClient(sptr) || !IsSetOperRehash(sptr))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-      return 0;
-    }
-
-  if ( !IsOperRehash(sptr) )
-    {
-      sendto_one(sptr,":%s NOTICE %s :You have no H flag", me.name, parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no H umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_restart.c ircd-hybrid-6.0/src/m_restart.c
--- ircd-hybrid-6.0.orig/src/m_restart.c	Fri Jun  9 02:59:07 2000
+++ ircd-hybrid-6.0/src/m_restart.c	Tue Jun  5 21:16:24 2001
@@ -99,15 +99,12 @@
                   char *parv[])
 {
   char buf[BUFSIZE]; 
-  if (!MyClient(sptr) || !IsAnOper(sptr))
+  if (!MyClient(sptr) || !IsSetOperDie(sptr))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-      return 0;
-    }
-
-  if ( !IsOperDie(sptr) )
-    {
-      sendto_one(sptr,":%s NOTICE %s :You have no D flag", me.name, parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no D umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_server.c ircd-hybrid-6.0/src/m_server.c
--- ircd-hybrid-6.0.orig/src/m_server.c	Fri Nov 24 18:24:37 2000
+++ ircd-hybrid-6.0/src/m_server.c	Wed Jun  6 18:34:20 2001
@@ -376,8 +376,8 @@
                          
         }
       
-      sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
-                           acptr->name, sptr->name);
+      sendto_realops_flag(UMODE_EXTERNAL, "Server %s being introduced by %s",
+			  acptr->name, sptr->name);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_set.c ircd-hybrid-6.0/src/m_set.c
--- ircd-hybrid-6.0.orig/src/m_set.c	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/src/m_set.c	Wed Jun  6 18:34:26 2001
@@ -171,9 +171,12 @@
   char *command;
   int cnum;
 
-  if (!MyClient(sptr) || !IsAnOper(sptr))
+  if (!MyClient(sptr) || !IsSetOperRehash(sptr))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no H umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
     }
 
@@ -450,7 +453,7 @@
                       if (server_was_split)
                         {
                           server_was_split = NO;
-                          sendto_ops_flags(FLAGS_SERVNOTICE, "split-mode deactived by manual override");
+                          sendto_ops_flag(UMODE_SERVNOTICE, "split-mode deactived by manual override");
                         }
 #if defined(PRESERVE_CHANNEL_ON_SPLIT) || defined(NO_JOIN_ON_SPLIT)
                       remove_empty_channels();
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_setname.c ircd-hybrid-6.0/src/m_setname.c
--- ircd-hybrid-6.0.orig/src/m_setname.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_setname.c	Wed Jun  6 18:34:49 2001
@@ -39,6 +39,7 @@
 #include "channel.h"
 #include "irc_string.h"
 #include "s_debug.h"
+#include "client.h"
 
 extern int valid_hostname(const char* hostname);
 extern int valid_username(const char* username);
@@ -117,7 +118,7 @@
   target = parv[1];
   hostname = parv[2];
 
-  if (!IsPrivileged(cptr))
+  if (!(IsServer(cptr) || CanDoSetname(cptr)))
     {
       sendto_one(cptr, form_str(ERR_UNKNOWNCOMMAND),
                  me.name, parv[0], "SETHOST");
@@ -145,10 +146,10 @@
   }
 
   if ((acptr = find_person(target, NULL))) {
-    sendto_ops_flags(FLAGS_SPY,
-                     "%s is rehosting %s (%s@%s) to \"%s\" while whistling innocently",
-                     sptr->name, acptr->name,
-                     acptr->username, acptr->host, hostname);
+    sendto_ops_flag(UMODE_SPY,
+		    "%s is rehosting %s (%s@%s) to \"%s\" while whistling innocently",
+		    sptr->name, acptr->name,
+		    acptr->username, acptr->host, hostname);
       if (sptr == acptr) {
          if (MyClient(acptr))
          sendto_one(acptr, ":%s NOTICE %s :your hostname is now set to \"%s\"",
@@ -196,7 +197,7 @@
   target = parv[1];
   username = parv[2];
 
-  if (!IsPrivileged(cptr))
+  if (!(IsServer(cptr) || CanDoSetname(cptr)))
     {
       sendto_one(cptr, form_str(ERR_UNKNOWNCOMMAND),
                  me.name, parv[0], "SETIDENT");
@@ -224,10 +225,10 @@
   }
 
   if ((acptr = find_person(target, NULL))) {
-    sendto_ops_flags(FLAGS_SPY,
-                     "%s is identing %s (%s@%s) to \"%s\" while whistling innocently",
-                     sptr->name, acptr->name,
-                     acptr->username, acptr->host, username);
+    sendto_ops_flag(UMODE_SPY,
+		    "%s is identing %s (%s@%s) to \"%s\" while whistling innocently",
+		    sptr->name, acptr->name,
+		    acptr->username, acptr->host, username);
       if (sptr == acptr) {
          if (MyClient(acptr))
          sendto_one(acptr, ":%s NOTICE %s :your ident is now set to \"%s\"",
@@ -282,7 +283,7 @@
       return 0;
     }
 
-  if (!IsPrivileged(cptr) && (find_person(target, NULL) != sptr))
+  if (!(IsServer(cptr) || CanDoSetname(cptr)) && (find_person(target, NULL) != sptr))
     {
       sendto_one(sptr, form_str(ERR_USERSDONTMATCH), me.name, parv[0]);
       return 0;
@@ -296,19 +297,19 @@
   }
 
   if ((acptr = find_server(target))) {
-    sendto_ops_flags(FLAGS_SERVNOTICE,
-                     "%s is making %s be \"%s\" while whistling innocently",
-                     sptr->name, acptr->name, realname);
+    sendto_ops_flag(UMODE_SERVNOTICE,
+		    "%s is making %s be \"%s\" while whistling innocently",
+		    sptr->name, acptr->name, realname);
     sendto_serv_butone(cptr, ":%s SETNAME %s :%s",
                        sptr->name,
                        target,
                        realname);
     ircsprintf(acptr->info, "%s", realname);
   } else if ((acptr = find_person(target, NULL))) {
-    sendto_ops_flags(FLAGS_SPY,
-                     "%s is naming %s (%s@%s) to \"%s\" while whistling innocently",
-                     sptr->name, acptr->name,
-                     acptr->username, acptr->host, realname);
+    sendto_ops_flag(UMODE_SPY,
+		    "%s is naming %s (%s@%s) to \"%s\" while whistling innocently",
+		    sptr->name, acptr->name,
+		    acptr->username, acptr->host, realname);
       if (sptr == acptr) {
          if (MyClient(acptr))
          sendto_one(acptr, ":%s NOTICE %s :your realname is now set to \"%s\"",
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_squit.c ircd-hybrid-6.0/src/m_squit.c
--- ircd-hybrid-6.0.orig/src/m_squit.c	Sat Jul 31 09:23:00 1999
+++ ircd-hybrid-6.0/src/m_squit.c	Wed Jun  6 18:34:56 2001
@@ -106,9 +106,12 @@
   struct Client*   acptr;
   char  *comment = (parc > 2 && parv[2]) ? parv[2] : cptr->name;
 
-  if (!IsPrivileged(sptr))
+  if (!(IsServer(sptr) || IsSetOperRemote(sptr)))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no R umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
     }
 
@@ -210,20 +213,20 @@
       return 0;
     }
 
-  if (MyClient(sptr) && !IsOperRemote(sptr) && !MyConnect(acptr))
+  if (MyClient(sptr) && !IsSetOperRemote(sptr) && !MyConnect(acptr))
     {
-      sendto_one(sptr,":%s NOTICE %s :You have no R flag",me.name,parv[0]);
+      sendto_one(sptr,":%s NOTICE %s :You have no R umode",me.name,parv[0]);
       return 0;
     }
 
   /*
   **  Notify all opers, if my local link is remotely squitted
   */
-  if (MyConnect(acptr) && !IsAnOper(cptr))
+  if (MyConnect(acptr) && IsServer(cptr))
     {
-      sendto_ops_butone(NULL, &me,
-                        ":%s WALLOPS :Received SQUIT %s from %s (%s)",
-                        me.name, server, get_client_name(sptr,FALSE), comment);
+      sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE,
+			     "%s received SQUIT %s from %s (%s)",
+			     me.name, server, get_client_name(sptr,FALSE), comment);
       log(L_TRACE, "SQUIT From %s : %s (%s)", parv[0], server, comment);
     }
   else if (MyConnect(acptr))
